indexing
   title:       "presents an example of SHORT_DURATION class usage";
   cluster:     "timedate/examples/test_sdr [timedate/examples/test_sdr]";
   project:     "The Universal Time & Date UTDC";
   copyright:   "SIG Computer, 1995";
   author:      "Alexei Simonov (alex@eiffel.ru)";
   original:    22,Sep,95;
   version:     1.0;
   done_at:     "SIG Computer (info@eiffel.ru)";
   license:     "GNU Library GPL - see included readme file";
   extrnl_name: "test_sdr.e";

class TEST_SHORT_DURATION

   inherit
      IO_USER

   creation
      make

   feature

      sd1, sd2, sd3, sd4 : SHORT_DURATION

      test_short_duration is

         do
            put_nl ("Initialize short_duration -------------");
            !! sd1.set_time (10, 0, 0.111);
            !! sd2.set_seconds (144000.444);
            !! sd3.set_from_milliseconds (-72000222);
            !! sd4.clear;
            put_nl (x.s_short_duration (sd1)); -- print variable
            put_nl (x.s_short_duration (sd2));
            put_nl (x.s_short_duration (sd3));
            put_nl (x.s_short_duration (sd4));

            put_nl (x.s_short_duration ((sd1 + sd2).multiply_by (2)));
            put_nl (x.s_short_duration ((sd4 - sd3).multiply_by (6) - sd2.divide_by (2)));
            put_nl (x.s_short_duration (sd2.multiply_by (sd2.ratio (sd4 - sd3)) + sd1.multiply_by (2)));

            -- compare the two dates
            mio.put_boolean( sd1.plus (sd3) < sd4 );
            mio.put_new_line; mio.put_new_line;

         end -- test_short_duration

      test_magic_calculation (seconds : REAL) is

         do
            put_nl ("Some magic calculation with long_duration ----");
            !! sd1.set_seconds( seconds );
            put_nl (x.s_short_duration (sd1));
            sd2 := sd1.multiply_by (10);
            put_nl (x.s_short_duration (sd2));
            mio.put_real ( sd2.as_hours); put_nl (" as hours");
            mio.put_real ( sd2.as_minutes); put_nl (" as minutes");
            mio.put_real ( sd2.as_seconds); put_nl (" as seconds");

            sd1 := ( sd2.minus( sd2.divide_by (5))).divide_by (8);
            put_nl (x.s_short_duration (sd1));
            mio.put_new_line
         end -- test_magic_calculation


      make is

         do
            test_magic_calculation (1000.020);
            test_magic_calculation (20000.0);
            test_magic_calculation (100.101);
            test_short_duration;

         end -- make

   end --  class TEST_SHORT_DURATION

